#ifndef	__DEFS_H
#define	__DEFS_H

#if	defined(__HIGHC__)
#	define	__HE386__
#endif
#if	defined(WIN32) || defined(_MSC_VER) || defined(__WATCOMC__) || defined(LINUX)
#	define	__HE32__
#endif

#if	defined(__HE386__)
#	if	!defined(_SPDEFS_H)
#		include	<spdefs.h>
#	endif
#endif
#if	defined(WIN32)
#	include	<wtypes.h>
#endif
#if	defined(__HE32__)
#	if	!defined(_DEFS32_H)
#		include	"defs32.h"
#	endif
#endif

#ifndef	_FAST
# if	defined(__HIGHC__)
#  ifndef	_CALLING_CONVERTION_PASCAL
#   define	_CALLING_CONVERTION_PASCAL	(_DEFAULT_CALLING_CONVENTION | _CALLEE_POPS_STACK)
#  endif
#  define	_FAST	_CC(_CALLING_CONVERTION_PASCAL)
# elif	defined(_MSC_VER) || defined(__WATCOMC__)
#  define	_FAST	__fastcall
# else
#  define	_FAST
# endif
#endif

/* compiler config	----------------------------------------------------*/
#if	defined(__HE386__)	/* for TOWNS High C Compiler */
#	define	CONFIG_USE_STRUPR		/* use strupr() */
#	define	CONFIG_USE_STRCMPI		/* use strcmpi() */

	typedef	unsigned char	BYTE;
	typedef	unsigned short	WORD;
	typedef	unsigned long	DWORD;
#endif

#if	defined(_MSC_VER) || defined(__WATCOMC__)
#	define	CONFIG_USE_STRUPR		/* use strupr() */
#	define	CONFIG_USE_STRCMPI		/* use strcmpi() */
#endif

#if	defined(LINUX)
#	define	CONFIG_UCWARN

	typedef	unsigned char	BYTE;
	typedef	unsigned short	WORD;
	typedef	unsigned long	DWORD;
#endif

/* kanji config	--------------------------------------------------------*/
#if	defined(WIN32)
#	define	CONFIG_USE_MBC			/* for iskan() */
#endif

/* i/o config	--------------------------------------------------------*/
#if	defined(LINUX)
#	define	COMMAND_PATH_ENV	"PATH"
#	define	COMMAND_PATH_SEP	":"
#else
#	define	COMMAND_PATH_ENV	"PATH"
#	define	COMMAND_PATH_SEP	";"
#endif

#if	defined(__HE386__) || defined(WIN32)
#	define	FOPEN_READ_TXT	"rt"
#	define	FOPEN_READ_BIN	"rb"
#	define	FOPEN_WRITE_TXT	"wt"
#	define	FOPEN_WRITE_BIN	"wb"
#else
#	define	FOPEN_READ_TXT	"r"
#	define	FOPEN_READ_BIN	"r"
#	define	FOPEN_WRITE_TXT	"w"
#	define	FOPEN_WRITE_BIN	"w"
#endif

#endif
