#ifndef	_CCI_H
#define	_CCI_H

#if	defined(_CCI_DLL_COMPILE) && defined(WIN32)
#	if	!defined(_DLLEXPORT)
#		define	_DLLEXPORT	_declspec(dllexport)
#	endif
#else
#	if	defined(_DLLEXPORT)
#		undef	_DLLEXPORT
#	endif
#	define	_DLLEXPORT
#endif

#define T_CHAR			0
#define T_UCHAR 		1
#define T_SHORT 		2
#define T_USHORT		3
#define T_LONG			4
#define T_ULONG 		5
#define T_FLOAT 		6
#define T_DOUBLE		7
#define T_POINT 		8
#define T_ARRY			9
#define T_FUNC			10
#define T_EXTF			11

#define	T_INT			T_LONG
#define	T_UINT			T_ULONG
#define T_VOID			T_INT

#define T_VOID			T_INT

#if	defined(WIN32)
#	pragma pack(push,4)
#endif
typedef struct
{
	char	   *name;
	char	   *addr;
	char		cast[5];
} CCIFUNC_T;
#if	defined(WIN32)
#	pragma pack(pop)
#endif

extern _DLLEXPORT int		CCI_init( int codeSize, int heepSize );
extern _DLLEXPORT int		CCI_exec( const char *func, int len,...);
extern _DLLEXPORT int		CCI_load( const char *file);
extern _DLLEXPORT int		CCI_setFunc( CCIFUNC_T *func );
extern _DLLEXPORT char	   *CCI_getErrMsg(void);

#endif
