#if	!defined(_CCICFG_H)
#define	_CCICFG_H

#if	!defined(_STDIO_H)
#	include	<stdio.h>
#endif

#if	defined(_CCI_DLL_COMPILE) && defined(WIN32)
#	if	!defined(_DLLEXPORT)
#		define	_DLLEXPORT	_declspec(dllexport)
#	endif
#else
#	if	defined(_DLLEXPORT)
#		undef	_DLLEXPORT
#	endif
#	define	_DLLEXPORT
#endif

#ifndef	ERR
#	define	ERR		(-1)
#endif
#ifndef	NORMAL
#	define	NORMAL	(0)
#endif

#if	defined(WIN32)
#	pragma pack(push,4)
#endif
typedef struct
{
	void	 *(* malloc)(size_t);
	void	  (* free)(void *);
	void	  (* FileOpenReserved);
	void	  (* FileCloseReserved);
	void	  (* ReadFileReserved);
} CCICFG_T;
#if	defined(WIN32)
#	pragma pack(pop)
#endif

extern _DLLEXPORT int		CCI_setCfg( CCICFG_T *ccicfg);

#endif
