#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#include	"defs.h"
#include	"lib.h"

#ifdef	__HIGHC__
	pragma	On(Align_labels);
#endif

#if 	0
char	   *strdup(char *str)
{
	char	   *p;
	static char dmy[256];

	if ((p = (char *) MALLOC(strlen(str) + 1)) == NULL)
	{
		/* ERR_disp("strdup Memory Alloc Error!!"); 	 */
		p = dmy;
	}
	strcpy(p, str);
	return p;
}
#endif

char * _FAST skipspc(char *str)
{
	while (isspace(*str) || *str == ',')
		str++;
	return str;
}

char * _FAST skipword(char *str)
{
	while (!isspace(*str) && *str != ',' && *str != '\n' && *str != '\0')
		str++;
	return str;
}

int _FAST inchr(int ch, char *ptn)
{
	int 		n;

	for (n = 0; ptn[n] != '\0'; n++)
	{
		if (ptn[n] == ch)
			return n;
	}
	return (-1);
}

int _FAST instr(char *str, char *ptn)
{
	int 		n, i;

	i = strlen(ptn) - strlen(str);
	for (n = 0; n <= i; n++)
	{
		if (strcmp(&(ptn[n]), str) == 0)
			return n;
	}
	return (-1);
}

int _FAST strcut(int max, char *av[], char *str)
{
	int 		ac = 0;

	while (ac < max && *str != '\0')
	{
		str = skipspc(str);
		if (*str == '#')
			break;
		else if (*str == '\"')
		{
			av[ac++] = ++str;
			while (*str != '\"' && *str != '\0')
				str++;
			if (*str != '\"')
				break;
			*(str++) = '\0';
		} else if (*str != '\n' && *str != '\0')
		{
			av[ac++] = str;
			str = skipword(str);
			if (*str != '\0')
				*(str++) = '\0';
		}
	}
	return ac;
}

char * _FAST strval(int *val, char *p)
{
	int 		n = 0;

	if (*p == '0')
	{
		p++;
		if (*p == 'X' || *p == 'x')
		{
			while (isxdigit(*p))
			{
				if (isdigit(*p))
					n = n * 16 + (*p - '0');
				else
					n = n * 16 + (toupper(*p) - 'A' + 10);
				p++;
			}

		} else
		{
			while (*p >= '0' && *p <= '7')
			{
				n = n * 8 + (*p - '0');
				p++;
			}
		}

	} else
	{
		while (isdigit(*p))
		{
			n = n * 10 + (*p - '0');
			p++;
		}
	}
	*val = n;
	return p;
}

int _FAST strbin(int mx, char *ptn[], char *str)
{
	int 		n, c;
	int 		bs = 0;

	while (bs <= mx)
	{
		n = (bs + mx) / 2;
		if ((c = strcmp(ptn[n], str)) == 0)
			return n;
		else if (c < 0)
			bs = n + 1;
		else
			mx = n - 1;
	}
	return (-1);
}

char	*strrev(char *s)
{
	size_t	len = strlen(s);
	char	ch, *p1 = s, *p2 = s + len - 1;

	len /= 2;
	while ( len-- > 0 )
	{
		ch    = *p1;
		*p1++ = *p2;
		*p2++ = ch;
	}
	return (s);
}

#if	0
#if	0
#define iskanji(c)	 ((0x81 <= c && c <= 0x9f) || (0xe0 <= c && c <= 0xfc))
#define iskanji2(c)  ((0x40 <= c && c <= 0x7e) || (0x80 <= c && c <= 0xfc))
int 		iskan(char *p)
{
	if ( iskanji(*p) && iskanji2(*(p + 1)) )
		return TRUE;
	else
		return FALSE;
}
#else
extern int		iskan(char *);
#endif

int _FAST kan_pos(char *p, int n)
{
	int 		i;

	for (i = n; i > 0;)
	{
		if (*p == '\0')
		{
			return (n - i);

		} else if (iskan(p))
		{
			i -= 2;
			p += 2;

		} else
		{
			i--;
			p++;
		}
	}
	return (n + i);
}
#endif
