#define	YYLEXTYPE	int



#include    <stdio.h>
#include    <string.h>
#include    <ctype.h>

#include    "defs.h"
#include    "lib.h"
#include    "token.h"
#include    "vcpu.h"
#include    "code.h"

#include "parse.h"
YYSTYPE	*yyasp, yylval, yyval;
extern	void	yydef();
char	yyerrflag = 0;
#define	yyerrok	yyerrflag = 0
int	yytoken = 0;
#define	yyclearin	yytoken = 0
#include <setjmp.h>
jmp_buf	yyjmp;
#define	YYACCEPT	longjmp(yyjmp, 1)
#define	YYABORT	longjmp(yyjmp, 2)
void	yya1()

{}
void	yya2()

{}
void	yya3()

{}
void	yya4()

{}
void	yya5()

{}
void	yya6()

{
		    register VALPTR *vp, *tp;
		    register CAST   *cp;

		    vp = (VALPTR *)(yyasp[1]);
		    cp = (CAST *)yysymb(sizeof(CAST));
		    cp->type = T_FUNC;
		    func_cp = cp->next = vp->cast;
		    cp->size = T_SIZE(T_FUNC);
		    vp->cast = cp;
		    vp->clas = C_CODE;

		    if ( (tp = get_cast(vp->name)) != NULL &&
			 	    tp->cast->type == T_FUNC ) {
			vp->addr = tp->addr;
		    	*((char **)(vp->addr)) = now_code_pos();
		    } else {
			vp->addr = yyheep(sizeof(char *));
		    	*((char **)(vp->addr)) = now_code_pos();
		    }

		    switch(cast_clas) {
		    case C_GLOB:
			glob_set(vp);
			break;
		    case C_LOCA:
			vp->next = loca_top;
			loca_top = vp;
			break;
		    }

		    stak_push();
		    stak_nst = sizeof(int) * (2 - 1);	/* epc & ebp */
		    stak_vac = 1;
		}
void	yya7()

{
		    stak_nst = 0;
		    stak_vac = (-1);
		}
void	yya8()

{
		    gen_jmp_flush();
		    stak_pop();
		    stak_pos = HEEPMAX;
		}
void	yya9()

{ yyerror("Parse Syntax Error"); }
void	yya10()

{
		    gen_op(CM_PUSH, T_POINT, 2);
		    gen_op(CM_BASE, T_POINT, 2);
		    gen_op(CM_ADDI, T_POINT, 4);
		    base_ptr = (int *)now_code_pos();
		    gen_addr(NULL);
		    func_ret = gen_label_make();
		}
void	yya11()

{
		    gen_label_set(func_ret, now_code_pos());
		    *base_ptr = stak_nst;

		    gen_op(CM_ADDI, T_POINT, 4);
		    gen_addr((char *)(0 - stak_nst));
		    gen_op(CM_POP, T_POINT, 2);
		    gen_op(CM_RET, 0, 0);
		}
void	yya12()

{}
#define	yya13	yydef
#define	yya14	yydef
#define	yya15	yydef
void	yya16()

{ cast_clas = C_STAK; }
#define	yya17	yydef
void	yya18()

{ cast_clas = C_GLOB; }
void	yya19()

{ cast_clas = C_LOCA; }
void	yya20()

{ cast_type = T_CHAR; }
void	yya21()

{ cast_type = T_SHORT; }
void	yya22()

{ cast_type = T_LONG; }
void	yya23()

{ cast_type = T_INT; }
void	yya24()

{ cast_type = T_UCHAR; }
void	yya25()

{ cast_type = T_USHORT; }
void	yya26()

{ cast_type = T_ULONG; }
void	yya27()

{ cast_type = T_UINT; }
void	yya28()

{ cast_type = T_UINT; }
void	yya29()

{ cast_type = T_FLOAT; }
void	yya30()

{ cast_type = T_DOUBLE; }
#define	yya31	yydef
#define	yya32	yydef
#define	yya33	yydef
void	yya34()

{
		    register VALPTR *vp;
		/*  register CAST   *cp; */
		    
		    vp = (VALPTR *)(yyasp[1]);
		    cast_ptr = vp->addr;
		    
		    if ( cast_clas == C_STAK ) {
			yyerror("Not Stack Data Init");
		    }
		    
		    if(vp->cast->type == T_ARRY) {
		      cast_ptr = *((char**)cast_ptr);
		    }
		    
		    
/*
		    cast_ptr = ((VALPTR ))($1))->addr;
*/
		}
#define	yya35	yydef
void	yya36()

{
		    switch(cast_init) {
		    case T_CHAR:   case T_UCHAR:
			*((char *)cast_ptr) = yyasp[0];
			cast_ptr += sizeof(char);
			break;
		    case T_SHORT:  case T_USHORT:
			*((short *)cast_ptr) = yyasp[0];
			cast_ptr += sizeof(short);
			break;
		    case T_LONG:   case T_ULONG:
			*((long *)cast_ptr) = yyasp[0];
			cast_ptr += sizeof(long);
			break;
		    case T_FLOAT:
			*((float *)cast_ptr) = *((float *)(yyasp[0]));
			cast_ptr += sizeof(float);
			break;
		    case T_DOUBLE:
			*((double *)cast_ptr) = *((double *)(yyasp[0]));
			cast_ptr += sizeof(double);
			break;
/*
		    case T_FLOAT:  case T_DOUBLE:
			yyerror("Not Init Float or Double");
		        break;
*/
		    case T_POINT:
			*((int *)cast_ptr) = yyasp[0];
			cast_ptr += sizeof(int);
		        break;
		    }
		}
#define	yya37	yydef
#define	yya38	yydef
#define	yya39	yydef
void	yya40()

{
		    register VALPTR *vp;
/*		    register CAST   ccp;*/
/*		    register int    size;*/
		    register char   *ptr  /*,pptr2*/  ;
/*		    register int    i,n,last_size,last_type;*/

		    vp = (VALPTR *)(yyasp[0]);
		    vp->clas = cast_clas;
		    switch(cast_clas) {
		    case C_GLOB:
			vp->addr = yyheep(vp->cast->size);
			
			if(vp->cast->type == T_ARRY) {
			  ptr = vp->addr;
			  vp->addr = yyheep(T_SIZE(T_INT));
			  *((char**)(vp->addr)) = ptr;
			}
			
			glob_set(vp);
			break;
		    case C_LOCA:
			vp->addr = yyheep(vp->cast->size);
			
			if(vp->cast->type == T_ARRY) {
			  ptr = vp->addr;
			  vp->addr = yyheep(T_SIZE(T_INT));
			  *((char**)(vp->addr)) = ptr;
			}
			
			stak_set(vp);
			break;
		    case C_STAK:
			stak_nst += (stak_vac * vp->cast->size);
		        stak_nst = alias(stak_nst);
			vp->addr = (char *)stak_nst;
			
			if(vp->cast->type == T_ARRY) {
			  ptr = vp->addr;
			  stak_nst += (stak_vac * T_SIZE(T_INT));
		          stak_nst = alias(stak_nst);
			  vp->addr = (char *)stak_nst;
			  
			  gen_op(CM_LEA, T_POINT, vp->clas);
			  gen_addr((char *)(ptr));
			  
			  gen_op(CM_EXG, T_POINT, 1);
			  
			  gen_op(CM_LEA, T_POINT, vp->clas);
			  gen_addr((char *)(vp->addr));
			  
			  gen_op(CM_STR, T_POINT, 1);
			}
			
			
			stak_set(vp);
			break;
		    }
		    yyval = yyasp[0];
		}
void	yya41()

{
		    register VALPTR *vp;

		    if ( cast_clas == C_STAK ) {
		        vp = (VALPTR *)yystak(sizeof(VALPTR));
		        vp->cast = (CAST *)yystak(sizeof(CAST));
		    } else {
		        vp = (VALPTR *)yysymb(sizeof(VALPTR));
		        vp->cast = (CAST *)yysymb(sizeof(CAST));
		    }
		    vp->name = (char *)(yyasp[0]);
		    vp->cast->type = cast_type;
		    vp->cast->next = NULL;
		    vp->cast->size = T_SIZE(cast_type);
		    cast_init = cast_type;
		    yyval = (int)vp;
		}
void	yya42()

{
		    register VALPTR *vp;
		    register CAST   *cp;

		    if ( cast_clas == C_STAK )
		    	cp = (CAST *)yystak(sizeof(CAST));
		    else
		    	cp = (CAST *)yysymb(sizeof(CAST));

		    vp = (VALPTR *)(yyasp[0]);
		    cp->type = T_POINT;
		    cp->next = vp->cast;
		    cp->size = T_SIZE(T_POINT);
		    vp->cast = cp;
		    cast_init = T_POINT;
		    yyval = (int)vp;
		}
void	yya43()

{
		    register VALPTR *vp;
		    register CAST   *cp;

		    if ( cast_clas == C_STAK )
		    	cp = (CAST *)yystak(sizeof(CAST));
		    else
		    	cp = (CAST *)yysymb(sizeof(CAST));

		    vp = (VALPTR *)(yyasp[3]);
		    cp->type = T_ARRY;
		    cp->next = vp->cast;
		    vp->cast = cp;
		    
		    while(1) {
		      cp->size = cp->next->size * yyasp[1];
		      if(cp->next->type != T_ARRY) break;
		      cp = cp->next;
		    }
		    yyval = (int)vp;
/*
		    vp = (VALPTR ))($1);
		    cp->type = T_ARRY;
		    cp->next = vp->cast;
		    cp->size = vp->cast->size   $3;
		    vp->cast = cp;
		    $$ = (int)vp;
*/
		}
void	yya44()

{
		    register VALPTR *vp;
		    register CAST   *cp;

		    if ( cast_clas == C_STAK )
		    	cp = (CAST *)yystak(sizeof(CAST));
		    else
		    	cp = (CAST *)yysymb(sizeof(CAST));

		    vp = (VALPTR *)(yyasp[2]);
		    cp->type = T_ARRY;
		    cp->next = vp->cast;
		    vp->cast = cp;
		    
		    while(1) {
		      cp->size = cp->next->size * 0;
		      if(cp->next->type != T_ARRY) break;
		      cp = cp->next;
		    }
		    yyval = (int)vp;
/*
		    vp = (VALPTR ))($1);
		    cp->type = T_ARRY;
		    cp->next = vp->cast;
		    cp->size = vp->cast->size   $3;
		    vp->cast = cp;
		    $$ = (int)vp;
*/
		}
void	yya45()

{
		    register VALPTR *vp;
		    register CAST   *cp;

		    if ( cast_clas == C_STAK )
		    	cp = (CAST *)yystak(sizeof(CAST));
		    else
		    	cp = (CAST *)yysymb(sizeof(CAST));

		    vp = (VALPTR *)(yyasp[4]);
		    cp->type = T_FUNC;
		    cp->next = vp->cast;
		    cp->size = T_SIZE(T_FUNC);
		    vp->cast = cp;
		    yyval = (int)vp;
		}
void	yya46()

{ yyval = yyasp[1]; }
void	yya47()

{
		    register VALPTR *vp;

		    vp = (VALPTR *)yystak(sizeof(VALPTR));
		    vp->cast = (CAST *)yystak(sizeof(CAST));
		    vp->name = NULL;
		    vp->cast->type = cast_type;
		    vp->cast->next = NULL;
		    vp->cast->size = T_SIZE(cast_type);
		    cast_init = cast_type;
		    yyval = (int)vp;
		}
void	yya48()

{
		    register VALPTR *vp;
		    register CAST   *cp;

		    cp = (CAST *)yystak(sizeof(CAST));
		    vp = (VALPTR *)(yyasp[0]);
		    cp->type = T_POINT;
		    cp->next = vp->cast;
		    cp->size = T_SIZE(T_POINT);
		    vp->cast = cp;
		    cast_init = T_POINT;
		    yyval = (int)vp;
		}
void	yya49()

{
		    register VALPTR *vp;
		    register CAST   *cp;

		    cp = (CAST *)yystak(sizeof(CAST));
		    vp = (VALPTR *)(yyasp[3]);
		    cp->type = T_ARRY;
		    cp->next = vp->cast;
		    cp->size = vp->cast->size * yyasp[1];
		    vp->cast = cp;
		    yyval = (int)vp;
		}
void	yya50()

{
		    register VALPTR *vp;
		    register CAST   *cp;

		    cp = (CAST *)yystak(sizeof(CAST));
		    vp = (VALPTR *)(yyasp[4]);
		    cp->type = T_FUNC;
		    cp->next = vp->cast;
		    cp->size = T_SIZE(T_FUNC);
		    vp->cast = cp;
		    yyval = (int)vp;
		}
void	yya51()

{ yyval = yyasp[1]; }
#define	yya52	yydef
void	yya53()

{ stak_push(); }
void	yya54()

{ stak_pop(); }
#define	yya55	yydef
#define	yya56	yydef
#define	yya57	yydef
#define	yya58	yydef
#define	yya59	yydef
#define	yya60	yydef
void	yya61()

{ cast_clas = C_STAK; }
#define	yya62	yydef
void	yya63()

{ cast_clas = C_STAK; }
#define	yya64	yydef
void	yya65()

{ cast_clas = C_LOCA; }
#define	yya66	yydef
void	yya67()

{}
void	yya68()

{
		    gen_label_set(yyasp[1], now_code_pos());
		}
void	yya69()

{
		    yyval = gen_label_make();
		    gen_op(CM_JMP, 0, 0);
		    gen_jmp_make(yyval, now_code_pos());
		    gen_addr(NULL);

		    gen_label_set(yyasp[2], now_code_pos());
		}
void	yya70()

{
		    gen_label_set(yyasp[1], now_code_pos());
		}
void	yya71()

{
		    yyval = gen_label_make();
		    gen_label_set(yyval, now_code_pos());
		    break_push();									/* add */
		    gen_label_set(break_now() + 1, now_code_pos());	/* add */
		}
void	yya72()

{
		    yyval = gen_label_make();
		    gen_op(CM_JE, 0, 0);
		    gen_jmp_make(yyval, now_code_pos());
		    gen_addr(NULL);
/*		    break_push();	delete */
		}
void	yya73()

{
		    gen_op(CM_JMP, 0, 0);
		    gen_jmp_make(yyasp[4], now_code_pos());
		    gen_addr(NULL);
		    gen_label_set(yyasp[1], now_code_pos());
		    gen_label_set(break_pop(), now_code_pos());
		}
void	yya74()

{
		    yyval = gen_label_make();
		    gen_label_set(yyval, now_code_pos());

		    break_push();
		    gen_label_set(break_now() + 1, now_code_pos());	/* add */
		}
void	yya75()

{
		    gen_op(CM_JNE, 0, 0);
		    gen_jmp_make(yyasp[6], now_code_pos());
		    gen_addr(NULL);

		    gen_label_set(break_pop(), now_code_pos());
		}
void	yya76()

{
		    yyval = gen_label_make();
		    gen_label_set(yyval, now_code_pos());
		    break_push();									/* add */
		    gen_label_set(break_now() + 1, now_code_pos());	/* add */
		}
void	yya77()

{
		    yyval = gen_label_make();
		    gen_op(yyasp[1] == FALSE ? CM_JMP:CM_JNE, 0, 0);
		    gen_jmp_make(yyval, now_code_pos());
		    gen_addr(NULL);

		    gen_label_make();		/* $$ + 1 */
		    gen_op(CM_JMP, 0, 0);
		    gen_jmp_make(yyval + 1, now_code_pos());
		    gen_addr(NULL);

		    gen_label_make();		/* $$ + 2 */
		    gen_label_set(yyval + 2, now_code_pos());
		}
void	yya78()

{
		    gen_op(CM_JMP, 0, 0);
		    gen_jmp_make(yyasp[5], now_code_pos());
		    gen_addr(NULL);

		    gen_label_set(yyasp[2], now_code_pos());
	/*	    break_push();	delete	*/
		}
void	yya79()

{
		    gen_op(CM_JMP, 0, 0);
		    gen_jmp_make(yyasp[4] + 2, now_code_pos());
		    gen_addr(NULL);

		    gen_label_set(yyasp[4] + 1, now_code_pos());
		    gen_label_set(break_pop(), now_code_pos());
		}
void	yya80()

{
		    yyval = gen_label_make();
		    gen_op(CM_JMP, 0, 0);
		    gen_jmp_make(yyval, now_code_pos());
		    gen_addr(NULL);
		    break_push();
		    switch_make();
		}
void	yya81()

{
		    gen_op(CM_JMP, 0, 0);
		    gen_jmp_make(break_now(), now_code_pos());
		    gen_addr(NULL);

		    gen_label_set(yyasp[2], now_code_pos());
		    switch_flush();

		    gen_label_set(break_pop(), now_code_pos());
		}
void	yya82()

{ case_make(yyasp[1], now_code_pos()); }
void	yya83()

{ default_make(now_code_pos()); }
void	yya84()

{
		    gen_op(CM_JMP, 0, 0);
		    gen_jmp_make(break_now(), now_code_pos());
		    gen_addr(NULL);
		}
void	yya85()

{
		    gen_op(CM_JMP, 0, 0);
		    gen_jmp_make(break_now() + 1, now_code_pos());
		    gen_addr(NULL);
		}
void	yya86()

{
/*
printf("func=%ld\n",func_cp->type);
*/
		    gen_code((NODE *)(yyasp[1]));
		    gen_conv( now_cp->type , func_cp->type , 0 );
		    make_node_flush();
		    gen_op(CM_JMP, 0, 0);
		    gen_jmp_make(func_ret, now_code_pos());
		    gen_addr(NULL);
		}
void	yya87()

{ gen_label_set(goto_make((char *)yyasp[1]), now_code_pos()); }
void	yya88()

{
		    gen_op(CM_JMP, 0, 0);
		    gen_jmp_make(goto_make((char *)yyasp[1]), now_code_pos());
		    gen_addr(NULL);
		}
void	yya89()

{
		    yyval = gen_label_make();
		    gen_op(CM_JE, 0, 0);
		    gen_jmp_make(yyval, now_code_pos());
		    gen_addr(NULL);
		}
void	yya90()

{ yyval = yyasp[2] & yyasp[0]; }
void	yya91()

{ yyval = yyasp[2] | yyasp[0]; }
void	yya92()

{ yyval = yyasp[2] ^ yyasp[0]; }
void	yya93()

{ yyval = yyasp[2] + yyasp[0]; }
void	yya94()

{ yyval = yyasp[2] - yyasp[0]; }
void	yya95()

{ yyval = yyasp[2] * yyasp[0]; }
void	yya96()

{ yyval = yyasp[2] / yyasp[0]; }
void	yya97()

{ yyval = yyasp[2] % yyasp[0]; }
void	yya98()

{ yyval = yyasp[2] << yyasp[0]; }
void	yya99()

{ yyval = yyasp[2] >> yyasp[0]; }
void	yya100()

{ yyval = !(yyasp[0]); }
void	yya101()

{ yyval = ~(yyasp[0]); }
void	yya102()

{ yyval = 0 - yyasp[0]; }
void	yya103()

{ yyval = yyasp[1]; }
void	yya104()

{ yyval = yyasp[0]; }
void	yya105()

{ yyval = yyasp[0]; }
void	yya106()

{ yyval = yyasp[0]; }
void	yya107()

{ yyval = yyasp[0]; }
void	yya108()

{ yyval = FALSE; }
void	yya109()

{ yyval = TRUE; }
void	yya110()

{ yyval = TRUE; }
void	yya111()

{
		    yyval = make_node('T', yyasp[0], 0);
		    gen_code((NODE *)(yyval));
		    make_node_flush();
		}
void	yya112()

{ yyval = FALSE; }
void	yya113()

{ yyval = TRUE; }
void	yya114()

{ yyval = TRUE; }
void	yya115()

{
		    gen_code((NODE *)(yyasp[0]));
		    make_node_flush();
		}
void	yya116()

{ yyval = 0; }
void	yya117()

{ yyval = make_node('p', 0, yyasp[0]); }
void	yya118()

{ yyval = make_node('p', yyasp[2], yyasp[0]); }
void	yya119()

{ yyval = make_node('@', yyasp[2], yyasp[0]); }
void	yya120()

{
		    register VALPTR *vp;

		    vp = (VALPTR *)(yyasp[1]);
		    yyval = make_node('E', vp->cast->size, 0);
		}
void	yya121()

{
		    register VALPTR *vp;

		    if ( (vp = get_cast((char *)(yyasp[0]))) == NULL )
			yyerror("'%s' is undefine");
		    yyval = make_node('E', vp->cast->size, 0);
		}
void	yya122()

{ yyval = make_node('c', yyasp[3], yyasp[1]); }
void	yya123()

{ yyval = make_node('&', yyasp[2], yyasp[0]); }
void	yya124()

{ yyval = make_node('|', yyasp[2], yyasp[0]); }
void	yya125()

{ yyval = make_node((CM_AND << 8) | 'V', yyasp[2], yyasp[0]); }
void	yya126()

{ yyval = make_node((CM_OR << 8) | 'V', yyasp[2], yyasp[0]); }
void	yya127()

{ yyval = make_node((CM_XOR << 8) | 'V', yyasp[2], yyasp[0]); }
void	yya128()

{ yyval = make_node((CM_ADD << 8) | 'V', yyasp[2], yyasp[0]); }
void	yya129()

{ yyval = make_node((CM_SUB << 8) | 'V', yyasp[2], yyasp[0]); }
void	yya130()

{ yyval = make_node((CM_MUL << 8) | 'V', yyasp[2], yyasp[0]); }
void	yya131()

{ yyval = make_node((CM_DIV << 8) | 'V', yyasp[2], yyasp[0]); }
void	yya132()

{ yyval = make_node((CM_MOD << 8) | 'V', yyasp[2], yyasp[0]); }
void	yya133()

{ yyval = make_node((CM_SHL << 8) | 'V', yyasp[2], yyasp[0]); }
void	yya134()

{ yyval = make_node((CM_SHR << 8) | 'V', yyasp[2], yyasp[0]); }
void	yya135()

{ yyval = make_node((CM_CE << 8) | 'x', yyasp[2], yyasp[0]); }
void	yya136()

{ yyval = make_node((CM_CNE << 8) | 'x', yyasp[2], yyasp[0]); }
void	yya137()

{ yyval = make_node((CM_CLT << 8) | 'x', yyasp[2], yyasp[0]); }
void	yya138()

{ yyval = make_node((CM_CGT << 8) | 'x', yyasp[2], yyasp[0]); }
void	yya139()

{ yyval = make_node((CM_CLE << 8) | 'x', yyasp[2], yyasp[0]); }
void	yya140()

{ yyval = make_node((CM_CGE << 8) | 'x', yyasp[2], yyasp[0]); }
void	yya141()

{ yyval = make_node((CM_NOT << 8) | 'v', yyasp[0], 0); }
void	yya142()

{ yyval = make_node((CM_NOT << 8) | 'v', yyasp[0], 0); }
void	yya143()

{ yyval = make_node((CM_NEG << 8) | 'v', yyasp[0], 0); }
void	yya144()

{ yyval = make_node('?', yyasp[4], make_node(' ', yyasp[2], yyasp[0]) ); }
void	yya145()

{ yyval = yyasp[1]; }
void	yya146()

{ yyval = yyasp[0]; }
void	yya147()

{ yyval = make_node('=', yyasp[2], yyasp[0]); }
void	yya148()

{ yyval = make_node((CM_AND << 8) | '=', yyasp[2], yyasp[0]); }
void	yya149()

{ yyval = make_node((CM_OR << 8) | '=', yyasp[2], yyasp[0]); }
void	yya150()

{ yyval = make_node((CM_XOR << 8) | '=', yyasp[2], yyasp[0]); }
void	yya151()

{ yyval = make_node((CM_ADD << 8) | '=', yyasp[2], yyasp[0]); }
void	yya152()

{ yyval = make_node((CM_SUB << 8) | '=', yyasp[2], yyasp[0]); }
void	yya153()

{ yyval = make_node((CM_MUL << 8) | '=', yyasp[2], yyasp[0]); }
void	yya154()

{ yyval = make_node((CM_DIV << 8) | '=', yyasp[2], yyasp[0]); }
void	yya155()

{ yyval = make_node((CM_MOD << 8) | '=', yyasp[2], yyasp[0]); }
void	yya156()

{ yyval = make_node((CM_SHL << 8) | '=', yyasp[2], yyasp[0]); }
void	yya157()

{ yyval = make_node((CM_SHR << 8) | '=', yyasp[2], yyasp[0]); }
void	yya158()

{ yyval = make_node((CM_INC << 8) | 'i', yyasp[1], 0); }
void	yya159()

{ yyval = make_node((CM_DEC << 8) | 'i', yyasp[1], 0); }
void	yya160()

{ yyval = make_node((CM_INC << 8) | 'l', yyasp[0], 0); }
void	yya161()

{ yyval = make_node((CM_DEC << 8) | 'l', yyasp[0], 0); }
void	yya162()

{ yyval = make_node('I', yyasp[0], 0); }
void	yya163()

{ yyval = make_node('D', yyasp[0], 0); }
void	yya164()

{ yyval = make_node('I',
		       make_node((CM_ADD << 8) | 'V', yyasp[3], yyasp[1]), 0); }
void	yya165()

{ yyval = make_node('E', yyasp[0], 0); }
void	yya166()

{ yyval = make_node('F', yyasp[0], 0); }
void	yya167()

{ yyval = make_node('S', yyasp[0], 0); }
void	yya168()

{ yyval = make_label_node((char *)yyasp[0]); }
#ifdef	YYDEBUG
#define	YYDISPLAY
char	*yypnames[] = {
"S' : program",
"program :",
"program : extdefs",
"extdefs : extdef",
"extdefs : extdefs extdef",
"extdef : clas_nul cast_nul data_list ;",
".1 :",
".2 :",
"extdef : clas_nul cast_nul data_one ( .1 param_list ) .2 func_stmt",
"extdef : error",
".3 :",
"func_stmt : { .3 stmt_nul }",
"func_stmt : ;",
"param_list : param_def",
"param_list : param_list , param_def",
"param_def :",
".4 :",
"param_def : cast_nul .4 data_ext",
"clas_nul :",
"clas_nul : STATIC",
"cast_nul : CHAR",
"cast_nul : SHORT",
"cast_nul : LONG",
"cast_nul : INT",
"cast_nul : UNSIGNED CHAR",
"cast_nul : UNSIGNED SHORT",
"cast_nul : UNSIGNED LONG",
"cast_nul : UNSIGNED INT",
"cast_nul : UNSIGNED",
"cast_nul : FLOAT",
"cast_nul : DOUBLE",
"data_list : data_def",
"data_list : data_list , data_def",
"data_def : data_ext",
".5 :",
"data_def : data_ext = .5 const_def",
"const_def : const",
"const_def : { const_list }",
"const_list : const_def",
"const_list : const_list , const_def",
"data_ext : data_one",
"data_one : LABEL",
"data_one : * data_one",
"data_one : data_one [ const ]",
"data_one : data_one [ ]",
"data_one : ( data_one ) ( )",
"data_one : ( data_one )",
"data_type :",
"data_type : * data_type",
"data_type : data_type [ const ]",
"data_type : ( data_type ) ( )",
"data_type : ( data_type )",
"stmts : stmt",
".6 :",
"stmts : { .6 stmt_nul }",
"stmt_nul :",
"stmt_nul : stmt_list",
"stmt_list : stmts",
"stmt_list : local_def",
"stmt_list : stmt_list stmts",
"stmt_list : stmt_list local_def",
".7 :",
"local_def : cast_nul .7 data_list ;",
".8 :",
"local_def : REGISTER cast_nul .8 data_list ;",
".9 :",
"local_def : STATIC cast_nul .9 data_list ;",
"stmt : gen_expr_nul ;",
"stmt : if_head stmts",
".10 :",
"stmt : if_head stmts ELSE .10 stmts",
".11 :",
".12 :",
"stmt : WHILE ( .11 test_expr ) .12 stmts",
".13 :",
"stmt : DO .13 stmts WHILE ( test_expr ) ;",
".14 :",
".15 :",
".16 :",
"stmt : FOR ( gen_expr_nul ; .14 test_expr_nul ; .15 gen_expr_nul ) .16 stmts",
".17 :",
"stmt : SWITCH ( gen_expr ) { .17 stmt_list }",
"stmt : CASE const :",
"stmt : DEFAULT :",
"stmt : BREAK ;",
"stmt : CONTINUE ;",
"stmt : RETURN expr ;",
"stmt : LABEL :",
"stmt : GOTO LABEL ;",
"if_head : IF ( test_expr )",
"const : const & const",
"const : const | const",
"const : const ^ const",
"const : const + const",
"const : const - const",
"const : const * const",
"const : const / const",
"const : const % const",
"const : const LEFT const",
"const : const RIGHT const",
"const : ! const",
"const : ~ const",
"const : - const",
"const : ( const )",
"const : + const",
"const : EXPR",
"const : DEXPR",
"const : STRING",
"test_expr_nul :",
"test_expr_nul : test_expr",
"test_expr_nul : test_expr_nul , test_expr",
"test_expr : expr",
"gen_expr_nul :",
"gen_expr_nul : gen_expr",
"gen_expr_nul : gen_expr_nul , gen_expr",
"gen_expr : expr",
"push_expr :",
"push_expr : expr",
"push_expr : push_expr , expr",
"expr : ( cast_nul data_type ) expr",
"expr : SIZEOF ( cast_nul data_type )",
"expr : SIZEOF LABEL",
"expr : expr ( push_expr )",
"expr : expr ANDAND expr",
"expr : expr OROR expr",
"expr : expr & expr",
"expr : expr | expr",
"expr : expr ^ expr",
"expr : expr + expr",
"expr : expr - expr",
"expr : expr * expr",
"expr : expr / expr",
"expr : expr % expr",
"expr : expr LEFT expr",
"expr : expr RIGHT expr",
"expr : expr EQU expr",
"expr : expr UNEQU expr",
"expr : expr > expr",
"expr : expr < expr",
"expr : expr BIG expr",
"expr : expr SML expr",
"expr : ! expr",
"expr : ~ expr",
"expr : - expr",
"expr : expr ? expr : expr",
"expr : ( expr )",
"expr : + expr",
"expr : expr = expr",
"expr : expr ANDLET expr",
"expr : expr ORLET expr",
"expr : expr XORLET expr",
"expr : expr ADDLET expr",
"expr : expr SUBLET expr",
"expr : expr MULLET expr",
"expr : expr DIVLET expr",
"expr : expr MODLET expr",
"expr : expr LEFTLET expr",
"expr : expr RIGHTLET expr",
"expr : expr INC",
"expr : expr DEC",
"expr : INC expr",
"expr : DEC expr",
"expr : * expr",
"expr : & expr",
"expr : expr [ expr ]",
"expr : EXPR",
"expr : DEXPR",
"expr : STRING",
"expr : LABEL",
};
#endif
#ifdef	YYDISPLAY
char	*yytnames[] = {
	"EOF",
	"error",
	"BREAK",
	"CASE",
	"CHAR",
	"CONTINUE",
	"DEFAULT",
	"DEFINE",
	"DO",
	"DOUBLE",
	"ELSE",
	"EXTERN",
	"FLOAT",
	"FOR",
	"GOTO",
	"IF",
	"IFDEF",
	"IFNDEF",
	"INCLUDE",
	"INT",
	"LONG",
	"REGISTER",
	"RETURN",
	"SHORT",
	"SIGNED",
	"SIZEOF",
	"STATIC",
	"STRUCT",
	"SWITCH",
	"TYPEDEF",
	"UNDEF",
	"UNION",
	"UNSIGNED",
	"VOID",
	"WHILE",
	"ANDAND",
	"OROR",
	"INC",
	"DEC",
	"ADDLET",
	"SUBLET",
	"MULLET",
	"DIVLET",
	"MODLET",
	"ANDLET",
	"ORLET",
	"XORLET",
	"EQU",
	"UNEQU",
	"LEFTLET",
	"RIGHTLET",
	"LEFT",
	"RIGHT",
	"SML",
	"BIG",
	"EXPR",
	"LABEL",
	"MENBA",
	"STRING",
	"DEXPR",
	"LINC",
	"LDEC",
	"LOW",
	"DEFS",
	"MAXM",
	"FUNC",
	"CAST_DEF",
};
#endif

#if	defined(WIN32)
#pragma pack(push,4)
#endif
typedef	struct {
	YYLEXTYPE	input;
	short	num;
} YYACT;
#if	defined(WIN32)
#pragma pack(pop)
#endif
void (*yya[])() = {
	0,
	yya1,
	yya2,
	yya3,
	yya4,
	yya5,
	yya6,
	yya7,
	yya8,
	yya9,
	yya10,
	yya11,
	yya12,
	yya13,
	yya14,
	yya15,
	yya16,
	yya17,
	yya18,
	yya19,
	yya20,
	yya21,
	yya22,
	yya23,
	yya24,
	yya25,
	yya26,
	yya27,
	yya28,
	yya29,
	yya30,
	yya31,
	yya32,
	yya33,
	yya34,
	yya35,
	yya36,
	yya37,
	yya38,
	yya39,
	yya40,
	yya41,
	yya42,
	yya43,
	yya44,
	yya45,
	yya46,
	yya47,
	yya48,
	yya49,
	yya50,
	yya51,
	yya52,
	yya53,
	yya54,
	yya55,
	yya56,
	yya57,
	yya58,
	yya59,
	yya60,
	yya61,
	yya62,
	yya63,
	yya64,
	yya65,
	yya66,
	yya67,
	yya68,
	yya69,
	yya70,
	yya71,
	yya72,
	yya73,
	yya74,
	yya75,
	yya76,
	yya77,
	yya78,
	yya79,
	yya80,
	yya81,
	yya82,
	yya83,
	yya84,
	yya85,
	yya86,
	yya87,
	yya88,
	yya89,
	yya90,
	yya91,
	yya92,
	yya93,
	yya94,
	yya95,
	yya96,
	yya97,
	yya98,
	yya99,
	yya100,
	yya101,
	yya102,
	yya103,
	yya104,
	yya105,
	yya106,
	yya107,
	yya108,
	yya109,
	yya110,
	yya111,
	yya112,
	yya113,
	yya114,
	yya115,
	yya116,
	yya117,
	yya118,
	yya119,
	yya120,
	yya121,
	yya122,
	yya123,
	yya124,
	yya125,
	yya126,
	yya127,
	yya128,
	yya129,
	yya130,
	yya131,
	yya132,
	yya133,
	yya134,
	yya135,
	yya136,
	yya137,
	yya138,
	yya139,
	yya140,
	yya141,
	yya142,
	yya143,
	yya144,
	yya145,
	yya146,
	yya147,
	yya148,
	yya149,
	yya150,
	yya151,
	yya152,
	yya153,
	yya154,
	yya155,
	yya156,
	yya157,
	yya158,
	yya159,
	yya160,
	yya161,
	yya162,
	yya163,
	yya164,
	yya165,
	yya166,
	yya167,
	yya168,
};
YYACT	yyia[] = {
	0,	20018,	/* 0 */
	YYEOF,	20001,
	YYERR,	4,
	STATIC,	5,
	0,	20009,	/* 1 */
	0,	20019,	/* 2 */
	0,	-1,	/* 3 */
	YYEOF,	20000,
	0,	20018,	/* 4 */
	YYEOF,	20002,
	YYLNK,	2,
	0,	20003,	/* 5 */
	0,	-1,	/* 6 */
	CHAR,	21,
	DOUBLE,	22,
	FLOAT,	23,
	INT,	24,
	LONG,	25,
	SHORT,	26,
	UNSIGNED,	27,
	0,	20004,	/* 7 */
	0,	20020,	/* 8 */
	0,	20030,	/* 9 */
	0,	20029,	/* 10 */
	0,	20023,	/* 11 */
	0,	20022,	/* 12 */
	0,	20021,	/* 13 */
	0,	20028,	/* 14 */
	CHAR,	36,
	INT,	37,
	LONG,	38,
	SHORT,	39,
	0,	-1,	/* 15 */
	LABEL,	40,
	'*',	41,
	'(',	43,
	0,	20024,	/* 16 */
	0,	20027,	/* 17 */
	0,	20026,	/* 18 */
	0,	20025,	/* 19 */
	0,	20041,	/* 20 */
	0,	-1,	/* 21 */
	YYLNK,	33,
	0,	-1,	/* 22 */
	YYLNK,	33,
	0,	-1,	/* 23 */
	';',	60,
	',',	58,
	0,	20040,	/* 24 */
	'(',	71,
	'[',	61,
	0,	20033,	/* 25 */
	'=',	72,
	0,	20031,	/* 26 */
	0,	20042,	/* 27 */
	0,	-1,	/* 28 */
	')',	73,
	'[',	61,
	0,	-1,	/* 29 */
	YYLNK,	33,
	0,	20005,	/* 30 */
	0,	-1,	/* 31 */
	']',	90,
	EXPR,	77,
	STRING,	78,
	DEXPR,	79,
	'+',	80,
	'-',	82,
	'!',	84,
	'~',	86,
	'(',	88,
	0,	20006,	/* 32 */
	0,	20034,	/* 33 */
	0,	20046,	/* 34 */
	0,	20040,	/* 35 */
	'[',	61,
	0,	20032,	/* 36 */
	0,	20105,	/* 37 */
	0,	20107,	/* 38 */
	0,	20106,	/* 39 */
	0,	-1,	/* 40 */
	YYLNK,	63,
	0,	-1,	/* 41 */
	YYLNK,	63,
	0,	-1,	/* 42 */
	YYLNK,	63,
	0,	-1,	/* 43 */
	YYLNK,	63,
	0,	-1,	/* 44 */
	YYLNK,	63,
	0,	20044,	/* 45 */
	0,	-1,	/* 46 */
	']',	137,
	'|',	121,
	'&',	123,
	'^',	125,
	LEFT,	117,
	RIGHT,	119,
	'+',	127,
	'-',	129,
	'*',	131,
	'/',	133,
	'%',	135,
	0,	20015,	/* 47 */
	YYLNK,	13,
	0,	-1,	/* 48 */
	'{',	143,
	YYLNK,	63,
	0,	-1,	/* 49 */
	')',	148,
	0,	20104,	/* 50 */
	0,	20102,	/* 51 */
	0,	20100,	/* 52 */
	0,	20101,	/* 53 */
	0,	-1,	/* 54 */
	')',	149,
	YYLNK,	93,
	0,	-1,	/* 55 */
	YYLNK,	63,
	0,	-1,	/* 56 */
	YYLNK,	63,
	0,	-1,	/* 57 */
	YYLNK,	63,
	0,	-1,	/* 58 */
	YYLNK,	63,
	0,	-1,	/* 59 */
	YYLNK,	63,
	0,	-1,	/* 60 */
	YYLNK,	63,
	0,	-1,	/* 61 */
	YYLNK,	63,
	0,	-1,	/* 62 */
	YYLNK,	63,
	0,	-1,	/* 63 */
	YYLNK,	63,
	0,	-1,	/* 64 */
	YYLNK,	63,
	0,	20043,	/* 65 */
	0,	20016,	/* 66 */
	0,	-1,	/* 67 */
	',',	169,
	')',	171,
	0,	20013,	/* 68 */
	0,	-1,	/* 69 */
	YYLNK,	106,
	0,	20035,	/* 70 */
	0,	20036,	/* 71 */
	YYLNK,	93,
	0,	20045,	/* 72 */
	0,	20103,	/* 73 */
	0,	20098,	/* 74 */
	YYLNK,	98,
	0,	20099,	/* 75 */
	YYLNK,	98,
	0,	20091,	/* 76 */
	YYLNK,	94,
	0,	20090,	/* 77 */
	YYLNK,	95,
	0,	20092,	/* 78 */
	YYLNK,	96,
	0,	20093,	/* 79 */
	YYLNK,	100,
	0,	20094,	/* 80 */
	YYLNK,	100,
	0,	20095,	/* 81 */
	0,	20096,	/* 82 */
	0,	20097,	/* 83 */
	0,	-1,	/* 84 */
	YYLNK,	33,
	0,	20015,	/* 85 */
	YYLNK,	13,
	0,	20007,	/* 86 */
	0,	20038,	/* 87 */
	0,	-1,	/* 88 */
	',',	181,
	'}',	183,
	0,	20017,	/* 89 */
	0,	20014,	/* 90 */
	0,	-1,	/* 91 */
	';',	184,
	'{',	185,
	0,	-1,	/* 92 */
	YYLNK,	106,
	0,	20037,	/* 93 */
	0,	20012,	/* 94 */
	0,	20010,	/* 95 */
	0,	20008,	/* 96 */
	0,	20039,	/* 97 */
	0,	20112,	/* 98 */
	'}',	20055,
	REGISTER,	240,
	STATIC,	248,
	BREAK,	225,
	CASE,	227,
	CONTINUE,	229,
	DEFAULT,	231,
	DO,	233,
	FOR,	234,
	GOTO,	236,
	IF,	238,
	RETURN,	242,
	SWITCH,	250,
	WHILE,	252,
	LABEL,	259,
	'{',	284,
	CHAR,	21,
	DOUBLE,	22,
	FLOAT,	23,
	INT,	24,
	LONG,	25,
	SHORT,	26,
	UNSIGNED,	27,
	SIZEOF,	245,
	INC,	254,
	DEC,	256,
	EXPR,	258,
	STRING,	261,
	DEXPR,	262,
	'&',	263,
	'+',	265,
	'-',	267,
	'*',	269,
	'!',	271,
	'~',	273,
	'(',	275,
	0,	-1,	/* 99 */
	';',	348,
	0,	-1,	/* 100 */
	YYLNK,	63,
	0,	-1,	/* 101 */
	';',	352,
	0,	-1,	/* 102 */
	':',	353,
	0,	20074,	/* 103 */
	0,	-1,	/* 104 */
	'(',	356,
	0,	-1,	/* 105 */
	LABEL,	358,
	0,	-1,	/* 106 */
	'(',	360,
	0,	-1,	/* 107 */
	YYLNK,	13,
	0,	-1,	/* 108 */
	LABEL,	363,
	YYLNK,	212,
	0,	-1,	/* 109 */
	LABEL,	367,
	'(',	368,
	0,	-1,	/* 110 */
	YYLNK,	13,
	0,	-1,	/* 111 */
	'(',	371,
	0,	-1,	/* 112 */
	'(',	373,
	0,	-1,	/* 113 */
	YYLNK,	243,
	0,	-1,	/* 114 */
	YYLNK,	243,
	0,	20165,	/* 115 */
	0,	20168,	/* 116 */
	':',	378,
	0,	20167,	/* 117 */
	0,	20166,	/* 118 */
	0,	-1,	/* 119 */
	YYLNK,	243,
	0,	-1,	/* 120 */
	YYLNK,	243,
	0,	-1,	/* 121 */
	YYLNK,	243,
	0,	-1,	/* 122 */
	YYLNK,	243,
	0,	-1,	/* 123 */
	YYLNK,	243,
	0,	-1,	/* 124 */
	YYLNK,	243,
	0,	-1,	/* 125 */
	CHAR,	21,
	DOUBLE,	22,
	FLOAT,	23,
	INT,	24,
	LONG,	25,
	SHORT,	26,
	UNSIGNED,	27,
	YYLNK,	243,
	0,	20053,	/* 126 */
	0,	20061,	/* 127 */
	0,	-1,	/* 128 */
	'}',	401,
	0,	20057,	/* 129 */
	0,	20052,	/* 130 */
	0,	20112,	/* 131 */
	'}',	20056,
	YYLNK,	190,
	0,	20058,	/* 132 */
	0,	-1,	/* 133 */
	';',	406,
	',',	404,
	0,	20112,	/* 134 */
	BREAK,	225,
	CASE,	227,
	CONTINUE,	229,
	DEFAULT,	231,
	DO,	233,
	FOR,	234,
	GOTO,	236,
	IF,	238,
	RETURN,	242,
	SWITCH,	250,
	WHILE,	252,
	LABEL,	259,
	'{',	284,
	YYLNK,	212,
	0,	20113,	/* 135 */
	0,	20115,	/* 136 */
	ADDLET,	415,
	SUBLET,	417,
	MULLET,	419,
	DIVLET,	421,
	MODLET,	423,
	ANDLET,	425,
	ORLET,	427,
	XORLET,	429,
	LEFTLET,	435,
	RIGHTLET,	437,
	'=',	447,
	OROR,	411,
	'?',	449,
	ANDAND,	409,
	'|',	451,
	'&',	453,
	'^',	455,
	EQU,	431,
	UNEQU,	433,
	SML,	443,
	BIG,	445,
	'<',	457,
	'>',	459,
	LEFT,	439,
	RIGHT,	441,
	'+',	461,
	'-',	463,
	'*',	465,
	'/',	467,
	'%',	469,
	INC,	413,
	DEC,	414,
	'[',	471,
	'(',	473,
	0,	20084,	/* 137 */
	0,	-1,	/* 138 */
	':',	475,
	YYLNK,	93,
	0,	20085,	/* 139 */
	0,	20083,	/* 140 */
	0,	20112,	/* 141 */
	YYLNK,	298,
	0,	20112,	/* 142 */
	YYLNK,	243,
	0,	-1,	/* 143 */
	';',	481,
	0,	-1,	/* 144 */
	YYLNK,	243,
	0,	20063,	/* 145 */
	0,	20168,	/* 146 */
	0,	-1,	/* 147 */
	';',	488,
	YYLNK,	314,
	0,	20121,	/* 148 */
	0,	-1,	/* 149 */
	YYLNK,	13,
	0,	20065,	/* 150 */
	0,	-1,	/* 151 */
	YYLNK,	243,
	0,	20071,	/* 152 */
	0,	20160,	/* 153 */
	YYLNK,	344,
	0,	20161,	/* 154 */
	YYLNK,	344,
	0,	20087,	/* 155 */
	0,	20163,	/* 156 */
	YYLNK,	346,
	0,	20146,	/* 157 */
	YYLNK,	346,
	0,	20143,	/* 158 */
	YYLNK,	346,
	0,	20162,	/* 159 */
	YYLNK,	346,
	0,	20141,	/* 160 */
	YYLNK,	344,
	0,	20142,	/* 161 */
	YYLNK,	344,
	0,	20047,	/* 162 */
	'*',	497,
	'(',	499,
	0,	-1,	/* 163 */
	')',	504,
	YYLNK,	314,
	0,	20112,	/* 164 */
	YYLNK,	189,
	0,	-1,	/* 165 */
	YYLNK,	33,
	0,	20011,	/* 166 */
	0,	20059,	/* 167 */
	0,	20060,	/* 168 */
	0,	-1,	/* 169 */
	YYLNK,	243,
	0,	20067,	/* 170 */
	0,	20068,	/* 171 */
	ELSE,	511,
	0,	-1,	/* 172 */
	YYLNK,	243,
	0,	-1,	/* 173 */
	YYLNK,	243,
	0,	20158,	/* 174 */
	0,	20159,	/* 175 */
	0,	-1,	/* 176 */
	YYLNK,	243,
	0,	-1,	/* 177 */
	YYLNK,	243,
	0,	-1,	/* 178 */
	YYLNK,	243,
	0,	-1,	/* 179 */
	YYLNK,	243,
	0,	-1,	/* 180 */
	YYLNK,	243,
	0,	-1,	/* 181 */
	YYLNK,	243,
	0,	-1,	/* 182 */
	YYLNK,	243,
	0,	-1,	/* 183 */
	YYLNK,	243,
	0,	-1,	/* 184 */
	YYLNK,	243,
	0,	-1,	/* 185 */
	YYLNK,	243,
	0,	-1,	/* 186 */
	YYLNK,	243,
	0,	-1,	/* 187 */
	YYLNK,	243,
	0,	-1,	/* 188 */
	YYLNK,	243,
	0,	-1,	/* 189 */
	YYLNK,	243,
	0,	-1,	/* 190 */
	YYLNK,	243,
	0,	-1,	/* 191 */
	YYLNK,	243,
	0,	-1,	/* 192 */
	YYLNK,	243,
	0,	-1,	/* 193 */
	YYLNK,	243,
	0,	-1,	/* 194 */
	YYLNK,	243,
	0,	-1,	/* 195 */
	YYLNK,	243,
	0,	-1,	/* 196 */
	YYLNK,	243,
	0,	-1,	/* 197 */
	YYLNK,	243,
	0,	-1,	/* 198 */
	YYLNK,	243,
	0,	-1,	/* 199 */
	YYLNK,	243,
	0,	-1,	/* 200 */
	YYLNK,	243,
	0,	-1,	/* 201 */
	YYLNK,	243,
	0,	-1,	/* 202 */
	YYLNK,	243,
	0,	-1,	/* 203 */
	YYLNK,	243,
	0,	-1,	/* 204 */
	YYLNK,	243,
	0,	20116,	/* 205 */
	YYLNK,	243,
	0,	20082,	/* 206 */
	0,	-1,	/* 207 */
	WHILE,	581,
	0,	-1,	/* 208 */
	';',	583,
	',',	404,
	0,	20088,	/* 209 */
	0,	-1,	/* 210 */
	')',	584,
	0,	20111,	/* 211 */
	YYLNK,	314,
	0,	-1,	/* 212 */
	YYLNK,	33,
	0,	20086,	/* 213 */
	0,	20047,	/* 214 */
	YYLNK,	392,
	0,	-1,	/* 215 */
	YYLNK,	33,
	0,	-1,	/* 216 */
	')',	594,
	0,	-1,	/* 217 */
	YYLNK,	243,
	0,	20047,	/* 218 */
	YYLNK,	392,
	0,	20047,	/* 219 */
	YYLNK,	392,
	0,	-1,	/* 220 */
	')',	604,
	'[',	602,
	0,	20145,	/* 221 */
	0,	-1,	/* 222 */
	'}',	606,
	0,	-1,	/* 223 */
	';',	607,
	',',	58,
	0,	20114,	/* 224 */
	0,	20069,	/* 225 */
	0,	20123,	/* 226 */
	YYLNK,	328,
	0,	20124,	/* 227 */
	YYLNK,	327,
	0,	20151,	/* 228 */
	YYLNK,	314,
	0,	20152,	/* 229 */
	YYLNK,	314,
	0,	20153,	/* 230 */
	YYLNK,	314,
	0,	20154,	/* 231 */
	YYLNK,	314,
	0,	20155,	/* 232 */
	YYLNK,	314,
	0,	20148,	/* 233 */
	YYLNK,	314,
	0,	20149,	/* 234 */
	YYLNK,	314,
	0,	20150,	/* 235 */
	YYLNK,	314,
	0,	20135,	/* 236 */
	YYLNK,	333,
	0,	20136,	/* 237 */
	YYLNK,	333,
	0,	20156,	/* 238 */
	YYLNK,	314,
	0,	20157,	/* 239 */
	YYLNK,	314,
	0,	20133,	/* 240 */
	YYLNK,	339,
	0,	20134,	/* 241 */
	YYLNK,	339,
	0,	20140,	/* 242 */
	YYLNK,	337,
	0,	20139,	/* 243 */
	YYLNK,	337,
	0,	20147,	/* 244 */
	YYLNK,	314,
	0,	-1,	/* 245 */
	':',	610,
	YYLNK,	314,
	0,	20126,	/* 246 */
	YYLNK,	329,
	0,	20125,	/* 247 */
	YYLNK,	330,
	0,	20127,	/* 248 */
	YYLNK,	331,
	0,	20138,	/* 249 */
	YYLNK,	337,
	0,	20137,	/* 250 */
	YYLNK,	337,
	0,	20128,	/* 251 */
	YYLNK,	341,
	0,	20129,	/* 252 */
	YYLNK,	341,
	0,	20130,	/* 253 */
	YYLNK,	344,
	0,	20131,	/* 254 */
	YYLNK,	344,
	0,	20132,	/* 255 */
	YYLNK,	344,
	0,	-1,	/* 256 */
	']',	612,
	YYLNK,	314,
	0,	20117,	/* 257 */
	YYLNK,	314,
	0,	-1,	/* 258 */
	',',	613,
	')',	615,
	0,	-1,	/* 259 */
	'(',	616,
	0,	20076,	/* 260 */
	0,	20089,	/* 261 */
	0,	-1,	/* 262 */
	';',	620,
	',',	58,
	0,	-1,	/* 263 */
	')',	621,
	'[',	602,
	0,	-1,	/* 264 */
	';',	622,
	',',	58,
	0,	-1,	/* 265 */
	'{',	623,
	0,	-1,	/* 266 */
	')',	624,
	0,	20048,	/* 267 */
	0,	-1,	/* 268 */
	')',	625,
	'[',	602,
	0,	-1,	/* 269 */
	YYLNK,	63,
	0,	-1,	/* 270 */
	YYLNK,	243,
	0,	20054,	/* 271 */
	0,	20062,	/* 272 */
	0,	20112,	/* 273 */
	YYLNK,	298,
	0,	-1,	/* 274 */
	YYLNK,	243,
	0,	20164,	/* 275 */
	0,	-1,	/* 276 */
	YYLNK,	243,
	0,	20122,	/* 277 */
	0,	-1,	/* 278 */
	YYLNK,	243,
	0,	20108,	/* 279 */
	YYLNK,	243,
	0,	20064,	/* 280 */
	0,	20120,	/* 281 */
	0,	20066,	/* 282 */
	0,	20080,	/* 283 */
	0,	20072,	/* 284 */
	0,	20051,	/* 285 */
	'(',	646,
	0,	-1,	/* 286 */
	']',	648,
	YYLNK,	93,
	0,	20119,	/* 287 */
	0,	20070,	/* 288 */
	0,	20144,	/* 289 */
	YYLNK,	325,
	0,	20118,	/* 290 */
	YYLNK,	314,
	0,	-1,	/* 291 */
	')',	649,
	0,	20109,	/* 292 */
	0,	-1,	/* 293 */
	',',	651,
	';',	653,
	0,	20112,	/* 294 */
	YYLNK,	190,
	0,	20112,	/* 295 */
	YYLNK,	298,
	0,	-1,	/* 296 */
	')',	658,
	0,	20049,	/* 297 */
	0,	-1,	/* 298 */
	';',	659,
	0,	-1,	/* 299 */
	YYLNK,	243,
	0,	20077,	/* 300 */
	0,	20112,	/* 301 */
	'}',	663,
	YYLNK,	190,
	0,	20073,	/* 302 */
	0,	20050,	/* 303 */
	0,	20075,	/* 304 */
	0,	20110,	/* 305 */
	0,	20112,	/* 306 */
	YYLNK,	243,
	0,	20081,	/* 307 */
	0,	-1,	/* 308 */
	')',	667,
	',',	404,
	0,	20078,	/* 309 */
	0,	20112,	/* 310 */
	YYLNK,	298,
	0,	20079,	/* 311 */
	0,	0
};
#if	defined(WIN32)
#pragma pack(push,4)
#endif
typedef	struct {
	short	old;
	short	new;
} YYGOTO;
#if	defined(WIN32)
#pragma pack(pop)
#endif
YYGOTO	yyg1[] = {
	0,	6,
	-1,	-1
};
YYGOTO	yyg2[] = {
	0,	8,
	-1,	-1
};
YYGOTO	yyg3[] = {
	0,	11,
	8,	20,
	-1,	-1
};
YYGOTO	yyg4[] = {
	0,	12,
	8,	12,
	-1,	-1
};
YYGOTO	yyg5[] = {
	12,	32,
	103,	138,
	169,	138,
	188,	285,
	240,	362,
	248,	370,
	275,	391,
	290,	285,
	368,	489,
	397,	285,
	642,	285,
	654,	285,
	-1,	-1
};
YYGOTO	yyg6[] = {
	32,	45,
	399,	507,
	486,	585,
	491,	591,
	-1,	-1
};
YYGOTO	yyg7[] = {
	32,	48,
	41,	54,
	43,	55,
	58,	74,
	167,	74,
	399,	74,
	486,	74,
	491,	74,
	-1,	-1
};
YYGOTO	yyg8[] = {
	71,	103,
	-1,	-1
};
YYGOTO	yyg9[] = {
	103,	139,
	-1,	-1
};
YYGOTO	yyg10[] = {
	171,	178,
	-1,	-1
};
YYGOTO	yyg11[] = {
	178,	186,
	-1,	-1
};
YYGOTO	yyg12[] = {
	185,	188,
	-1,	-1
};
YYGOTO	yyg13[] = {
	188,	286,
	397,	505,
	-1,	-1
};
YYGOTO	yyg14[] = {
	103,	142,
	169,	177,
	-1,	-1
};
YYGOTO	yyg15[] = {
	138,	167,
	-1,	-1
};
YYGOTO	yyg16[] = {
	32,	51,
	58,	51,
	167,	176,
	399,	51,
	486,	51,
	491,	51,
	-1,	-1
};
YYGOTO	yyg17[] = {
	32,	53,
	58,	76,
	399,	53,
	486,	53,
	491,	53,
	-1,	-1
};
YYGOTO	yyg18[] = {
	72,	105,
	-1,	-1
};
YYGOTO	yyg19[] = {
	105,	145,
	143,	172,
	181,	187,
	-1,	-1
};
YYGOTO	yyg20[] = {
	61,	91,
	80,	110,
	82,	111,
	84,	112,
	86,	113,
	88,	114,
	105,	146,
	117,	150,
	119,	152,
	121,	154,
	123,	156,
	125,	158,
	127,	160,
	129,	162,
	131,	164,
	133,	165,
	135,	166,
	143,	146,
	181,	146,
	227,	349,
	602,	627,
	-1,	-1
};
YYGOTO	yyg21[] = {
	143,	173,
	-1,	-1
};
YYGOTO	yyg22[] = {
	391,	501,
	489,	588,
	497,	598,
	499,	599,
	-1,	-1
};
YYGOTO	yyg23[] = {
	188,	288,
	290,	402,
	297,	407,
	354,	476,
	397,	288,
	608,	631,
	642,	288,
	644,	657,
	654,	402,
	668,	670,
	-1,	-1
};
YYGOTO	yyg24[] = {
	188,	289,
	290,	289,
	297,	289,
	354,	289,
	397,	289,
	608,	289,
	642,	289,
	644,	289,
	654,	289,
	668,	289,
	-1,	-1
};
YYGOTO	yyg25[] = {
	284,	397,
	-1,	-1
};
YYGOTO	yyg26[] = {
	188,	290,
	397,	290,
	642,	654,
	-1,	-1
};
YYGOTO	yyg27[] = {
	188,	293,
	290,	403,
	397,	293,
	642,	293,
	654,	403,
	-1,	-1
};
YYGOTO	yyg28[] = {
	285,	399,
	-1,	-1
};
YYGOTO	yyg29[] = {
	362,	486,
	-1,	-1
};
YYGOTO	yyg30[] = {
	370,	491,
	-1,	-1
};
YYGOTO	yyg31[] = {
	188,	294,
	290,	294,
	297,	294,
	354,	294,
	356,	478,
	397,	294,
	608,	294,
	642,	294,
	644,	294,
	654,	294,
	661,	664,
	668,	294,
	-1,	-1
};
YYGOTO	yyg32[] = {
	188,	297,
	290,	297,
	297,	297,
	354,	297,
	397,	297,
	608,	297,
	642,	297,
	644,	297,
	654,	297,
	668,	297,
	-1,	-1
};
YYGOTO	yyg33[] = {
	511,	608,
	-1,	-1
};
YYGOTO	yyg34[] = {
	373,	495,
	-1,	-1
};
YYGOTO	yyg35[] = {
	360,	482,
	495,	596,
	616,	636,
	618,	638,
	651,	660,
	-1,	-1
};
YYGOTO	yyg36[] = {
	624,	644,
	-1,	-1
};
YYGOTO	yyg37[] = {
	233,	354,
	-1,	-1
};
YYGOTO	yyg38[] = {
	583,	618,
	-1,	-1
};
YYGOTO	yyg39[] = {
	618,	639,
	-1,	-1
};
YYGOTO	yyg40[] = {
	653,	661,
	-1,	-1
};
YYGOTO	yyg41[] = {
	667,	668,
	-1,	-1
};
YYGOTO	yyg42[] = {
	188,	312,
	290,	312,
	297,	312,
	354,	312,
	356,	312,
	371,	493,
	397,	312,
	404,	510,
	608,	312,
	642,	312,
	644,	312,
	654,	312,
	661,	312,
	668,	312,
	-1,	-1
};
YYGOTO	yyg43[] = {
	623,	642,
	-1,	-1
};
YYGOTO	yyg44[] = {
	188,	313,
	242,	364,
	254,	374,
	256,	376,
	263,	379,
	265,	381,
	267,	383,
	269,	385,
	271,	387,
	273,	389,
	275,	394,
	290,	313,
	297,	313,
	354,	313,
	356,	313,
	360,	484,
	371,	313,
	397,	313,
	404,	313,
	409,	512,
	411,	514,
	415,	516,
	417,	518,
	419,	520,
	421,	522,
	423,	524,
	425,	526,
	427,	528,
	429,	530,
	431,	532,
	433,	534,
	435,	536,
	437,	538,
	439,	540,
	441,	542,
	443,	544,
	445,	546,
	447,	548,
	449,	550,
	451,	553,
	453,	555,
	455,	557,
	457,	559,
	459,	561,
	461,	563,
	463,	565,
	465,	567,
	467,	569,
	469,	571,
	471,	573,
	473,	576,
	495,	484,
	604,	630,
	608,	313,
	610,	632,
	613,	634,
	616,	484,
	618,	484,
	642,	313,
	644,	313,
	651,	484,
	654,	313,
	661,	313,
	668,	313,
	-1,	-1
};
YYGOTO	yyg45[] = {
	473,	578,
	-1,	-1
};
YYGOTO	*yyg[] = {
	0,
	yyg1,
	yyg1,
	yyg2,
	yyg2,
	yyg3,
	yyg8,
	yyg10,
	yyg3,
	yyg3,
	yyg12,
	yyg11,
	yyg11,
	yyg9,
	yyg9,
	yyg14,
	yyg15,
	yyg14,
	yyg4,
	yyg4,
	yyg5,
	yyg5,
	yyg5,
	yyg5,
	yyg5,
	yyg5,
	yyg5,
	yyg5,
	yyg5,
	yyg5,
	yyg5,
	yyg6,
	yyg6,
	yyg17,
	yyg18,
	yyg17,
	yyg19,
	yyg19,
	yyg21,
	yyg21,
	yyg16,
	yyg7,
	yyg7,
	yyg7,
	yyg7,
	yyg7,
	yyg7,
	yyg22,
	yyg22,
	yyg22,
	yyg22,
	yyg22,
	yyg23,
	yyg25,
	yyg23,
	yyg13,
	yyg13,
	yyg26,
	yyg26,
	yyg26,
	yyg26,
	yyg28,
	yyg27,
	yyg29,
	yyg27,
	yyg30,
	yyg27,
	yyg24,
	yyg24,
	yyg33,
	yyg24,
	yyg34,
	yyg36,
	yyg24,
	yyg37,
	yyg24,
	yyg38,
	yyg40,
	yyg41,
	yyg24,
	yyg43,
	yyg24,
	yyg24,
	yyg24,
	yyg24,
	yyg24,
	yyg24,
	yyg24,
	yyg24,
	yyg32,
	yyg20,
	yyg20,
	yyg20,
	yyg20,
	yyg20,
	yyg20,
	yyg20,
	yyg20,
	yyg20,
	yyg20,
	yyg20,
	yyg20,
	yyg20,
	yyg20,
	yyg20,
	yyg20,
	yyg20,
	yyg20,
	yyg39,
	yyg39,
	yyg39,
	yyg35,
	yyg31,
	yyg31,
	yyg31,
	yyg42,
	yyg45,
	yyg45,
	yyg45,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
	yyg44,
};
short	yylen[] = {
	1,
	0,
	1,
	1,
	2,
	4,
	0,
	0,
	9,
	1,
	0,
	4,
	1,
	1,
	3,
	0,
	0,
	3,
	0,
	1,
	1,
	1,
	1,
	1,
	2,
	2,
	2,
	2,
	1,
	1,
	1,
	1,
	3,
	1,
	0,
	4,
	1,
	3,
	1,
	3,
	1,
	1,
	2,
	4,
	3,
	5,
	3,
	0,
	2,
	4,
	5,
	3,
	1,
	0,
	4,
	0,
	1,
	1,
	1,
	2,
	2,
	0,
	4,
	0,
	5,
	0,
	5,
	2,
	2,
	0,
	5,
	0,
	0,
	7,
	0,
	8,
	0,
	0,
	0,
	12,
	0,
	8,
	3,
	2,
	2,
	2,
	3,
	2,
	3,
	4,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	2,
	2,
	2,
	3,
	2,
	1,
	1,
	1,
	0,
	1,
	3,
	1,
	0,
	1,
	3,
	1,
	0,
	1,
	3,
	5,
	5,
	2,
	4,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	2,
	2,
	2,
	5,
	3,
	2,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	2,
	2,
	2,
	2,
	2,
	2,
	4,
	1,
	1,
	1,
	1,
};
#include "yaccpar.c"


