#ifndef	_VCPU_H
#define	_VCPU_H

#define CM_JMP			0		/* jmp */
#define CM_JE			1		/* == */
#define CM_JNE			2		/* != */
#define CM_CE			3		/* == */
#define CM_CNE			4		/* != */
#define CM_CLT			5		/* > */
#define CM_CLE			6		/* >= */
#define CM_CGT			7		/* < */
#define CM_CGE			8		/* <= */
#define CM_AND			9		/* */
#define CM_OR			10
#define CM_XOR			11
#define CM_ADD			12
#define CM_SUB			13
#define CM_MUL			14
#define CM_DIV			15
#define CM_MOD			16
#define CM_SHL			17
#define CM_SHR			18
#define CM_NEG			19
#define CM_NOT			20
#define CM_JMPR 		21		/* jmp */
#define CM_PUSH 		22		/* push */
#define CM_POP			23		/* pop */
#define CM_CNV			24		/* movsx */
#define CM_UCNV 		25		/* movzx */
#define CM_TEST 		26		/* test */
#define CM_EXG			27		/* xchg */
#define CM_LD			28		/* mov ?,? */
#define CM_LDR			29		/* mov ?,[eax] */
#define CM_ST			30		/* mov ?,? */
#define CM_STR			31		/* mov [eax],? */
#define CM_RET			32		/* ret */
#define CM_INC			33		/* inc */
#define CM_DEC			34		/* dec */
#define CM_LEA			35		/* lea */
#define CM_BASE 		36		/* sub ?,n */
#define CM_ADDI 		37		/* add ?,n */
#define CM_MULI 		38		/* mul ?,n */
#define CM_DIVI 		39		/* div ?,n */
#define CM_CALR 		40		/* call ? */
#define CM_CALI 		41		/* call n */
#define CM_CMPI 		42		/* cmp ?,n */

#endif
