#ifndef	_HE386_H
#define	_HE386_H

#ifndef	_MML_H
#	include	"mml.h"
#endif

#define	C_GRAY		C_WHITE
#define	C_DARK		C_HBLACK
#define	C_WARNNING	C_HYELLOW
#define	C_ERROR		C_HRED
#define	C_INFO		C_HGREEN
#define	C_TIMEBOX	C_CYAN
#define	C_GRAY0		C_HBLACK
#define	C_GRAY1		C_RED
#define	C_GRAY2		C_WHITE
#define	C_GRAY3		C_MAGENTA
#define	C_METAL0	C_GREEN
#define	C_METAL1	C_CYAN
#define	C_METAL2	C_YELLOW
#define	C_DLGBASE	C_MAGENTA

/*	ϥ⡼	--------------------------------------------------------*/
#define	_HE_MSG_INF		(0)		/* ̾				*/
#define	_HE_MSG_MPP		(1)		/* ץץå	*/
#define	_HE_MSG_CTR		(2)		/* ȥԾ	*/
#define	_HE_MSG_REM		(3)		/* 				*/
#define	_HE_MSG_INP		(4)		/* ץץå	*/
#define	_HE_MSG_OUT		(5)		/* ץץå	*/
#define	_HE_MSG_TXT		(6)		/* ƥȽ			*/
#define	_HE_MSG_LIN		(7)		/* Խ				*/
#define	_HE_MSG_ERR		(8)		/* 顼			*/
#define	_HE_MSG_DEB		(9)		/* ǥХå			*/
#define	_HE_MSG_DE1		(10)	/* ǥХå	#1		*/
#define	_HE_MSG_DE2		(11)	/* ǥХå	#2		*/
#define	_HE_MSG_DE3		(12)	/* ǥХå	#3		*/
#define	_HE_MSG_DE4		(13)	/* ǥХå	#4		*/

/*	"main.c"	--------------------------------------------------------*/
extern char		CciPath[];
extern char		CciFileName[];

#if	defined(__HE386__)
extern int		USR_putc( int ch );
#	define		USR_putcStderr	USR_putc
extern int		USR_fputc( int ch, FILE *fp );
extern void		USR_puts( CONST char *s );
#	define		USR_putsStderr	USR_puts
extern void		USR_fputs( CONST char *s, FILE *fp );
extern void		USR_printf( CONST char *form, ... );
extern void		USR_fprintf( FILE *fp, CONST char *form, ... );
extern int		USR_getch(void);
#else
#	define	USR_putc(_ch)		putc((_ch),stdout)
#	define	USR_putcStderr(_ch)	putc((_ch),stderr)
#	define	USR_fputc(_ch,_fp)	fputc((_ch),_fp)
#	define	USR_puts(_s)		fputs((_s),stdout)
#	define	USR_putsStderr(_s)	fputs((_s),stderr)
#	define	USR_fputs(_s,_fp)	fputs((_s),_fp)
#	define	USR_printf			printf
#	define	USR_fprintf			fprintf
#	define	USR_getch			getch
#endif

/*	"he386.c"	--------------------------------------------------------*/
extern void		HE_puts( MMSQR_T *sqr, int mode, CONST char *s );
extern void		HE_printf( MMSQR_T *sqr, int mode, CONST char *form, ... );
extern void		he386_break(void);
extern void		he386_term(void);
extern void		he386_error(void);
extern int		he386_main(void);
extern int		he386_genarate( MMSQR_T *sqr, MMCLK_T clk );

#endif
