#ifndef	_LISTWORK_H
#define	_LISTWORK_H

#ifndef	__DEFS_H
#	include	"_defs.h"
#endif

typedef struct _listdata
{
	struct _listdata	   *next;
	unsigned int			att;
	size_t					siz;
	void				   *ptr;
} LISTDATA;

typedef struct
{
	LISTDATA			   *datTop;
	LISTDATA			   *datLast;
	int						numDat;
	size_t					sizDat;
} LISTWORK;

extern void       _FAST	listwork_init( LISTWORK *listwork);
extern void       _FAST	list_clear( LISTWORK *listwork);
extern LISTDATA * _FAST	list_allocData(size_t size);
extern LISTDATA * _FAST	list_allocName(const char *name);
extern void       _FAST	list_linkData( LISTWORK *listwork, LISTDATA *listdata );
extern int        _FAST	list_linkPutf( LISTWORK *listwork, const char *form, ... );
extern int        _FAST	list_sort( LISTWORK *listwork, LISTDATA ***tblptr, int (*compfunc)(const LISTDATA **, const LISTDATA **) );

#endif
