/*************************************************************************
*	"main32.c" -- he386 main modules
*************************************************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<stdarg.h>
#include	<ctype.h>
#include	<string.h>
#include	<time.h>
#include	<setjmp.h>

#include	"he386.h"
#include	"mmoption.h"
#include	"mml.h"
#include	"mmlib.h"
#define		_MSG_DEFINE
#include	"mmsg.h"
#define		_MSGDAT_DEFINE
#include	"msgdat.h"
#include	"mmfile.h"
#include	"cci.h"
#include	"ccicfg.h"

static jmp_buf		JmpBuf;

void	userbreak(int level)
{
	he386_break();
	longjmp(JmpBuf, level);
}

/*************************************************************************
*	ƥ
*************************************************************************/

static int		init(int *argc, char **argv[], int _argc, char **_argv)
{
	*argc = _argc;
	*argv = _argv;

#ifdef	_DEBUG
	printf("argv[0] = %s\n", *argv[0]);
#endif
	/* ưǥ쥯ȥ	*/
	if ( FS_setStartPath( StartPath, *argv[0] ) )
		return (ERR);

	{
		static CCICFG_T	CciCfg = 
		{
			malloc,
			free  ,
			NULL  ,
			NULL  ,
			NULL  ,
		};
		CCI_setCfg( &CciCfg );
	}

	return (NORMAL);
}

static void	term(int errLevel)
{
}

int		main(int _argc, char *_argv[])
{
	int			i, ret;
	int 		argc;
	char		**argv;

	if ( init(&argc,&argv,_argc,_argv) )
	{
		ret = 1;
	} else
	{
		if ( (i = setjmp(JmpBuf)) > 0 )
		{
			ret = i;
		} else
		{
			if ( argc > 1 && set_option(argc,argv) )
			{
				ret = 1;
			} else
			{
				he386_main();
				ret = 0;
			}
		}
		term(ret);
	}

	return (ret);
}
