#ifndef	_MMFILE_H
#define	_MMFILE_H

#ifdef	__HE386__
#	ifndef	_SPFUNC_H
#		include	<spfunc.h>
#	endif
#	ifndef	_FSLIB_H
#		include	"fslib.h"
#	endif
#endif

#if	defined(__HE32__)
#	if	!defined(_DEFS32_H)
#		include	"defs32.h"
#	endif

/*	"filelib.c"		----------------------------------------------------*/

extern char		StartPath[256];
extern int		FsPathDelim;
extern int		FsDosDelim;

extern char	   *GetSizeStr( long siz, char *buf );
extern int		iskan( CONST char *s );
extern char	   *FS_addFnam( char *path, const char *fnam);
extern void		FS_dos2unix( char *_unix, CONST char *_dos);
extern void		FS_unix2dos( char *_dos, CONST char *_unix);

extern int		FS_argSet( CONST char *s, char **argv[] );
extern void		FS_argClear( int argc, char **argv );
extern void		FS_appendSnam( char *df, CONST char *ef, CONST char *sub );
extern void		FS_getDnamPath( char *directory, CONST char *pathname );
extern char	   *FS_getFnam( char *fnam, CONST char *filename );
extern int		FS_getFnamPath( char *filename, CONST char *pathname );
extern char	   *FS_getSnam( char *snam, CONST char *filename );
extern int		FS_setStartPath( char *start, CONST char *cmd);

/*----------------------------------------------------------------------*/
extern int		FS_getdrv(void);
extern int		FS_chdrv(int drv);
extern int		FS_getdir(char *name);
extern int		FS_chdir( const char *dir );
extern int		FS_getdir2( char *name );

/*----------------------------------------------------------------------*/
#define	FS_fopen(_fn,_md)	fopen(_fn,_md)
#define	FS_fclose(_fp)		fclose(_fp)
#define	FS_remove(_fn)		remove(_fn)
#define	FS_ISDELIM(_ch)	( (_ch) == FsPathDelim || (_ch) == FsDosDelim )

#define	SP_FCLOSE			fclose
#define	SP_FOPEN			fopen

#endif	/* end of ifdef __HE32__ */

#endif
