#ifndef	_MMPART_H
#define	_MMPART_H

#ifndef	_MML_H
#	include	"mml.h"
#endif

extern int			MMpart_init( MMSQR_T *sqr );
extern void			MMpart_term( MMSQR_T *sqr );
extern void			MMpart_free( MMTRK_T *trk );
extern int			MMpart_clear( MMTRK_T *trk, MMPART_T *part );
extern MMPART_T * _FAST MMpart_get( MMTRK_T *trk, int partNo);

/*	"mmpart10.c"	----------------------------------------------------*/
extern MMCLK_T _FAST mmpart_get_clock( REG MMPART_T *part );
extern int _FAST	mmpart_set_tempo( MMPART_T *part, MMCLK_T clk, MMVALUE_T *val );
extern int _FAST	mmpart_set_midich( MMPART_T *part, int ch );
extern int _FAST	mmpart_set_delay( MMPART_T *part, MMVALUE_T *val );
extern int _FAST	mmpart_set_keyShift( MMPART_T *part, MMVALUE_T *val );
extern int _FAST	mmpart_set_octave( MMPART_T *part, MMVALUE_T *val );
extern int _FAST	mmpart_set_velocity( MMPART_T *part, MMVALUE_T *val );
extern int _FAST	mmpart_set_offVelocity( MMPART_T *part, MMVALUE_T *val );
extern int _FAST	mmpart_set_steptime( MMPART_T *part, MMVALUE_T *val );
extern int _FAST	mmpart_set_gatetime( MMPART_T *part, MMVALUE_T *val );
extern int _FAST	mmpart_set_gateratio( MMPART_T *part, MMVALUE_T *val );
extern int _FAST	mmpart_set_prog( MMPART_T *part, MMCLK_T clk, MMVALUE_T *val );
extern int _FAST	mmpart_set_pitch( MMPART_T *part, MMCLK_T clk, MMVALUE_T *val );
extern int _FAST	mmpart_set_caf( MMPART_T *part, MMCLK_T clk, MMVALUE_T *val );
extern int _FAST	mmpart_set_cafPres( MMPART_T *part, MMVALUE_T *val );
extern int _FAST	mmpart_set_cafDelay( MMPART_T *part, MMVALUE_T *val );
extern int _FAST	mmpart_set_paf( MMPART_T *part, MMCLK_T clk, int note, MMVALUE_T *val );
extern int _FAST	mmpart_set_pafPres( MMPART_T *part, MMVALUE_T *val );
extern int _FAST	mmpart_set_pafDelay( MMPART_T *part, MMVALUE_T *val );
extern int _FAST	mmpart_set_cc( MMPART_T *part, MMCLK_T clk, int cc, MMVALUE_T *val );

/*----------------------------------------------------------------------*/
extern int _FAST	MMdec_partCmd( MMSQR_T *sqr, MMPART_T *part, CONST char **s );

/*----------------------------------------------------------------------*/
#define	MMPART_SQR(_part)	( ((MMTRK_T *)((_part)->trk))->sqr )
#define	MMPART_CLK(_part)	( (_part)->clk + (MM_READVALUE(&((_part)->set.delay)) + MM_READVALUE(&((_part)->ofs.delay))) )

#endif
