#ifndef	_MSGDAT_H
#define	_MSGDAT_H

#ifdef	__HE386__
#	ifndef	_SPDEFS_H
#		include	<spdefs.h>
#	endif
#endif
#ifdef	__HE86__
#	ifndef	_HE86LIB_H
#		include	"he86lib.h"
#	endif
#endif

#ifdef	_MSGDAT_DEFINE
#	define	EXT
#	define	INI(p)	p
#else
#	define	EXT		extern
#	define	INI(p)
#endif

/*----------------------------------------------------------------------*/
#define	_MAIN_VERSION	"3.02a"
#define	_MAIN_EDITION	"#01"

#if	defined(__HE386__)
EXT CONST char	_HE386P_[]              INI(= "HE386P" );
#endif

/*----------------------------------------------------------------------*/
/*	ĥ																*/
EXT CONST char	_SNAM_MML[]             INI(= ".mml" );
EXT CONST char	_SNAM_EUP[]             INI(= ".eup" );
EXT CONST char	_SNAM_MID[]             INI(= ".mid" );

/*----------------------------------------------------------------------*/
/*	顼å													*/
/*EXT CONST char	_EOF_ENCOUNTERED[]      INI(= "EOF encountered" );*/
/*EXT CONST char	_FILE_NAME_MUST_BE_IDENTIFIER[]
                                        INI(= "File name must be identifier!" );*/
/*EXT CONST char	_FILE_OPEN_ERROR[]      INI(= "File open error!" );*/
/*EXT CONST char	_MACRO_NAME_MUST_BE_IDENTIFIER[]
                                        INI(= "Macro name must be identifier!" );*/
/*EXT CONST char	_MML_SYNTAX_ERROR[]     INI(= "MML syntax error!" );*/
EXT CONST char	_OUT_OF_MEMORY[]        INI(= "Out of memory!" );
EXT CONST char	_OUT_OF_STRING_SPACE[]  INI(= "Out of string space!" );
EXT CONST char	_TOO_MANY_NESTED_IF_STATEMENTS[]
                                        INI(= "Too many nested #if statements!" );
EXT CONST char	_TOO_LONG_MACRO_NAME[]  INI(= "Too long macro name!" );
/*EXT CONST char	_TOO_MANY_FILE_OPEN[]   INI(= "Too many file open!" );*/
EXT CONST char	_VELOCITY_ERROR[]       INI(= "Velocity error!" );

/*----------------------------------------------------------------------*/
EXT CONST char	_MM_CAF_[]              INI(= "caf:"     );
EXT CONST char	_MM_CAFDELAY_[]         INI(= "cafdelay:");
EXT CONST char	_MM_CAFPRES_[]          INI(= "cafpres:" );
EXT CONST char	_MM_CD_[]               INI(= "cd:"      );
EXT CONST char	_MM_CC_[]               INI(= "cc:"      );
EXT CONST char	_MM_CH_[]               INI(= "ch:"      );
EXT CONST char	_MM_DELAY_[]            INI(= "delay:"   );
EXT CONST char	_MM_D_[]                INI(= "d:"       );
EXT CONST char	_MM_GATE_[]             INI(= "gate:"    );
EXT CONST char	_MM_G_[]                INI(= "g:"       );
EXT CONST char	_MM_GATEPER_[]          INI(= "gateper:" );
EXT CONST char	_MM_GP_[]               INI(= "gp:"      );
EXT CONST char	_MM_KEY_[]              INI(= "key:"     );
EXT CONST char	_MM_K_[]                INI(= "k:"       );
EXT CONST char	_MM_OCTAVE_[]           INI(= "octave:"  );
EXT CONST char	_MM_O_[]                INI(= "o:"       );
EXT CONST char	_MM_OFF_[]              INI(= "off:"     );
EXT CONST char	_MM_OFFVEL_[]           INI(= "offvel:"  );
EXT CONST char	_MM_OV_[]               INI(= "ov:"      );
EXT CONST char	_MM_PAF_[]              INI(= "paf:"     );
EXT CONST char	_MM_PAFDELAY_[]         INI(= "pafdelay:");
EXT CONST char	_MM_PAFPRES_[]          INI(= "pafpres:" );
EXT CONST char	_MM_PD_[]               INI(= "pafdelay:");
EXT CONST char	_MM_PITCH_[]            INI(= "pitch:"   );
EXT CONST char	_MM_P_[]                INI(= "p:"       );
EXT CONST char	_MM_PROG_[]             INI(= "prog:"    );
EXT CONST char	_MM_PG_[]               INI(= "pg:"      );
EXT CONST char	_MM_STEP_[]             INI(= "step:"    );
EXT CONST char	_MM_S_[]                INI(= "s:"       );
EXT CONST char	_MM_TEMPO_[]            INI(= "tempo:"   );
EXT CONST char	_MM_T_[]                INI(= "t:"       );
EXT CONST char	_MM_VEL_[]              INI(= "vel:"     );
EXT CONST char	_MM_V_[]                INI(= "v:"       );

/*----------------------------------------------------------------------*/
EXT CONST char	_caf_[]                 INI(= "caf"      );
EXT CONST char	_cafdelay_[]            INI(= "cafdelay" );
EXT CONST char	_cafpres_[]             INI(= "cafpres"  );
EXT CONST char	_cc_[]                  INI(= "cc"       );
EXT CONST char	_ch_[]                  INI(= "ch"       );
EXT CONST char	_clock_[]               INI(= "clock"    );
EXT CONST char	_delay_[]               INI(= "delay"    );
EXT CONST char	_excl_[]                INI(= "excl"     );
EXT CONST char	_gate_[]                INI(= "gate"     );
EXT CONST char	_gateper_[]             INI(= "gateper"  );
EXT CONST char	_keyshift_[]            INI(= "keyshift" );
EXT CONST char	_note_[]                INI(= "note"     );
EXT CONST char	_off_[]                 INI(= "off"      );
EXT CONST char	_offvel_[]              INI(= "offvel"   );
EXT CONST char	_on_[]                  INI(= "on"       );
EXT CONST char	_paf_[]                 INI(= "paf"      );
EXT CONST char	_pafdelay_[]            INI(= "pafdelay" );
EXT CONST char	_pafpres_[]             INI(= "pafpres"  );
EXT CONST char	_pitch_[]               INI(= "pitch"    );
EXT CONST char	_prog_[]                INI(= "prog"     );
EXT CONST char	_pres_[]                INI(= "pres"     );
EXT CONST char	_step_[]                INI(= "step"     );
EXT CONST char	_tempo_[]               INI(= "tempo"    );
EXT CONST char	_vel_[]                 INI(= "vel"      );

/*----------------------------------------------------------------------*/
EXT CONST char	_Channel_after_touch_[]    INI(= "Channel-after-touch"    );
EXT CONST char	_Polyphonic_after_touch_[] INI(= "Polyphonic-after-touch" );

/*----------------------------------------------------------------------*/

#undef	EXT
#undef	INI
#endif
