#include	<stdio.h>
#include	<stdlib.h>

#include	<cci.h>
#include	<ccicfg.h>

int		FS_getc(FILE *fp)
{
	return getc(fp);
}
int	FS_ungetc(int c, FILE *fp)
{
	return ungetc(c,fp);
}

static CCICFG_T	CciCfg = 
{
	malloc,
	free  ,
	NULL  ,
	NULL  ,
	NULL  ,
};

extern void		gen_init(void);

int		main(int ac, char *av[])
{
	CCI_setCfg( &CciCfg );
	if ( CCI_init( 256*1024, 256*1024) )
		return (1);
	gen_init();

	if ( CCI_load(av[1]) )
	{
		printf("Parse error : %s\n", CCI_getErrMsg() );
		return 1;
	}
	CCI_exec("main", 2, ac, av);

	return 0;
}
