#include	<stdio.h>
#include	<stdlib.h>
#include	<math.h>

#include	<spdefs.h>
#include	"cci.h"

#ifdef	__HIGHC__
#pragma Off(Warn)
#endif

static CCIFUNC_T ext_tbl[] =
{
	{"acos",		(char *) acos,			{T_DOUBLE, T_EXTF, ERR}},
	{"asin",		(char *) asin,			{T_DOUBLE, T_EXTF, ERR}},
	{"atan",		(char *) atan,			{T_DOUBLE, T_EXTF, ERR}},
	{"atan2",		(char *) atan2,			{T_DOUBLE, T_EXTF, ERR}},
	{"ceil",		(char *) ceil,			{T_DOUBLE, T_EXTF, ERR}},
	{"cos",			(char *) cos,			{T_DOUBLE, T_EXTF, ERR}},
	{"cosh",		(char *) cosh,			{T_DOUBLE, T_EXTF, ERR}},
	{"exp",			(char *) exp,			{T_DOUBLE, T_EXTF, ERR}},
	{"fabs",		(char *) fabs,			{T_DOUBLE, T_EXTF, ERR}},
	{"floor",		(char *) floor,			{T_DOUBLE, T_EXTF, ERR}},
	{"fmod",		(char *) fmod,			{T_DOUBLE, T_EXTF, ERR}},
	{"frexp",		(char *) frexp,			{T_DOUBLE, T_EXTF, ERR}},
	{"ldexp",		(char *) ldexp,			{T_DOUBLE, T_EXTF, ERR}},
	{"log10",		(char *) log10,			{T_DOUBLE, T_EXTF, ERR}},
	{"log",			(char *) log,			{T_DOUBLE, T_EXTF, ERR}},
	{"modf",		(char *) modf,			{T_DOUBLE, T_EXTF, ERR}},
	{"pow",			(char *) pow,			{T_DOUBLE, T_EXTF, ERR}},
	{"sin",			(char *) sin,			{T_DOUBLE, T_EXTF, ERR}},
	{"sinh",		(char *) sinh,			{T_DOUBLE, T_EXTF, ERR}},
	{"sqrt",		(char *) sqrt,			{T_DOUBLE, T_EXTF, ERR}},
	{"tab",			(char *) tan,			{T_DOUBLE, T_EXTF, ERR}},
	{"tabh",		(char *) tanh,			{T_DOUBLE, T_EXTF, ERR}},

#if	0
	{"_cabs",		(char *) cabs,			{T_DOUBLE, T_EXTF, ERR}},
	{"_hypot",		(char *) hypot,		{T_DOUBLE, T_EXTF, ERR}},
#endif
	NULL
};

#pragma On(Warn)


int		DOUBLE_setFunc(void)
{
	int		i;

	for ( i = 0; ext_tbl[i].name != NULL; ++i )
		FUNC_set( &ext_tbl[i] );
	return (NORMAL);
}

